<script setup>
import {computed, ref, watch} from 'vue'
import { Dialog, DialogPanel, DialogTitle, TransitionChild, TransitionRoot } from '@headlessui/vue'
import { XMarkIcon } from '@heroicons/vue/24/outline'
import CartItem from './CartItem.vue'
import { useProductsStore } from "../../stores/products.js";


const props = defineProps({
  open: Boolean,
  default: false
})

const emits = defineEmits(['close-click'])

const productsStore = useProductsStore()

const total = computed(() => {
  return productsStore.cart.reduce((sum, item) => sum + item.price, 0)
})

const showModal = ref(false);

const handleClose = () => {
  showModal.value = false
  emits('close-click', false)
}

watch(
  () => props.open,
  open => {
    showModal.value = open;
  },
);

const removeAll = () => {
  productsStore.cart = []
}

</script>


<template>
  <TransitionRoot as="template" :show="showModal">
    <Dialog as="div" class="relative z-10" @close="handleClose">
      <TransitionChild as="template" enter="ease-in-out duration-500" enter-from="opacity-0" enter-to="opacity-100" leave="ease-in-out duration-500" leave-from="opacity-100" leave-to="opacity-0">
        <div class="fixed inset-0 bg-gray-500 bg-opacity-75 transition-opacity" />
      </TransitionChild>

      <div class="fixed inset-0 overflow-hidden">
        <div class="absolute inset-0 overflow-hidden">
          <div class="pointer-events-none fixed inset-y-0 right-0 flex max-w-full pl-10">
            <TransitionChild as="template" enter="transform transition ease-in-out duration-500 sm:duration-700" enter-from="translate-x-full" enter-to="translate-x-0" leave="transform transition ease-in-out duration-500 sm:duration-700" leave-from="translate-x-0" leave-to="translate-x-full">
              <DialogPanel class="pointer-events-auto w-screen max-w-md">
                <div class="flex h-full flex-col overflow-y-scroll bg-white shadow-xl">
                  <div class="flex-1 overflow-y-auto py-6 px-4 sm:px-6">
                    <div class="flex items-start justify-between">
                      <DialogTitle class="text-lg font-medium text-gray-900">Shopping cart</DialogTitle>
                      <div class="ml-3 flex h-7 items-center">
                        <button type="button" class="-m-2 p-2 text-gray-400 hover:text-gray-500" @click="handleClose">
                          <span class="sr-only">Close panel</span>
                          <XMarkIcon class="h-6 w-6" aria-hidden="true" />
                        </button>
                      </div>
                    </div>

                    <div class="mt-8">
                      <div class="flow-root">
                        <ul role="list" class="-my-6 divide-y divide-gray-200">
                          <CartItem
                            v-for="product in productsStore.cart"
                            :key="product.id"
                            class="flex py-6"
                            :product="product"
                          />
                        </ul>
                      </div>
                    </div>
                  </div>

                  <div class="border-t border-gray-200 py-6 px-4 sm:px-6">
                    <div class="flex justify-between text-base font-medium text-gray-900">
                      <p>Order Total:</p>
                      <p>${{ total }}</p>
                    </div>
                    <div class="flex justify-between text-base font-medium text-gray-900 mt-6">
                      <p>Content:</p>
                      <button
                        type="button"
                        class="font-medium text-black-600 hover:text-black-500 underline"
                        @click="removeAll(product)"
                      >Remove all
                      </button>
                    </div>
                    <div class="mt-6">
                      <a 
                        href="#" 
                        class="flex items-center justify-center font-medium w-full bg-black px-4 py-4 sm:px-6 text-md text-white hover:opacity-80"
                        >Checkout
                      </a>
                    </div>
                  </div>
                </div>
              </DialogPanel>
            </TransitionChild>
          </div>
        </div>
      </div>
    </Dialog>
  </TransitionRoot>
</template>
